Index: codes/icosagcm/trunk/param_sets/dcmip2012/test3/run.def
===================================================================
--- codes/icosagcm/trunk/param_sets/dcmip2012/test3/run.def	(revision 92)
+++ codes/icosagcm/trunk/param_sets/dcmip2012/test3/run.def	(revision 101)
@@ -44,4 +44,7 @@
 write_period=12500
 
+# pression value to interpolate output : real (default=0, no output)
+out_pression_level=0.
+
 # etat0 : initial state : string (default=jablonowsky06) : 
 # jablonowsky06, academic, ncar
@@ -71,8 +74,9 @@
 
 
+
 # ------------------------------ Dissipation ---------------------------
 
 # dissipation time graddiv : real (default=5000)
-tau_graddiv = 1800
+tau_graddiv = 900
 
 # number of iteration for graddiv : integer (default=1)
@@ -81,5 +85,5 @@
 
 # dissipation time nxgradrot (default=5000)
-tau_gradrot = 1800
+tau_gradrot = 900
 
 # number of iteration for nxgradrot : integer (default=1)
@@ -88,5 +92,5 @@
 
 # dissipation time divgrad (theta) (default=5000)
-tau_divgrad=1800
+tau_divgrad= 900
 
 # number of iteration for divgrad : integer (default=1)
@@ -96,4 +100,13 @@
 
 
+# -------------------- physics ------------------------------------------
+
+# kind of physics : string : none, dcmip (default=none)
+physics=dcmip
+
+# testcase physics for dcmip : INTEGER : 1, 2 (default=1)
+dcmip_physics=1
+
+# -----------------------------------------------------------------------
 
 
@@ -120,3 +133,6 @@
 ncar_disvert_c=1
 
+# dcmip 4 testcase : integer (default=1) : 1, 2
+dcmip4_testcase=1
+
 #-----------------------------------------------------------------------
Index: codes/icosagcm/trunk/param_sets/dcmip2012/test4/test4.1/test4.1-0/job_lynx
===================================================================
--- codes/icosagcm/trunk/param_sets/dcmip2012/test4/test4.1/test4.1-0/job_lynx	(revision 92)
+++ codes/icosagcm/trunk/param_sets/dcmip2012/test4/test4.1/test4.1-0/job_lynx	(revision 101)
@@ -2,7 +2,7 @@
 #PBS -N icosagcm              
 #PBS -q workshop                 
-#PBS -l mppwidth=60          
+#PBS -l mppwidth=160          
 ##PBS -l mppnppn=12              
-#PBS -l walltime=00:30:00      
+#PBS -l walltime=01:00:00      
 #PBS -e icosagcm.out             
 #PBS -j eo                     
@@ -12,3 +12,3 @@
 export MPICH_MAX_SHORT_MSG_SIZE=1024
 	           
-aprun -n 60 ./icosa_gcm.exe > out         
+aprun -n 160 ./icosa_gcm.exe > out         
Index: codes/icosagcm/trunk/param_sets/dcmip2012/test4/test4.1/test4.1-0/run.def
===================================================================
--- codes/icosagcm/trunk/param_sets/dcmip2012/test4/test4.1/test4.1-0/run.def	(revision 92)
+++ codes/icosagcm/trunk/param_sets/dcmip2012/test4/test4.1/test4.1-0/run.def	(revision 101)
@@ -7,6 +7,6 @@
 
 # sub splitting of main rhombus : integer (default=1)
-nsplit_i=2
-nsplit_j=3
+nsplit_i=4
+nsplit_j=4
 
 # Number of vertical layer (llm) : integer (default=19)
@@ -44,4 +44,8 @@
 write_period=86400
 
+# pression value whera output is interpolated : real (default=0, no output)
+out_pression_level=85000
+
+
 # etat0 : initial state : string (default=jablonowsky06) : 
 # jablonowsky06, academic, ncar
@@ -74,5 +78,5 @@
 
 # dissipation time graddiv : real (default=5000)
-tau_graddiv = 1800
+tau_graddiv = 350
 
 # number of iteration for graddiv : integer (default=1)
@@ -81,5 +85,5 @@
 
 # dissipation time nxgradrot (default=5000)
-tau_gradrot = 1800
+tau_gradrot = 350
 
 # number of iteration for nxgradrot : integer (default=1)
@@ -88,5 +92,5 @@
 
 # dissipation time divgrad (theta) (default=5000)
-tau_divgrad=1800
+tau_divgrad=350
 
 # number of iteration for divgrad : integer (default=1)
Index: codes/icosagcm/trunk/param_sets/dcmip2012/test4/test4.1/test4.1-1/run.def
===================================================================
--- codes/icosagcm/trunk/param_sets/dcmip2012/test4/test4.1/test4.1-1/run.def	(revision 92)
+++ codes/icosagcm/trunk/param_sets/dcmip2012/test4/test4.1/test4.1-1/run.def	(revision 101)
@@ -7,6 +7,6 @@
 
 # sub splitting of main rhombus : integer (default=1)
-nsplit_i=2
-nsplit_j=3
+nsplit_i=4
+nsplit_j=4
 
 # Number of vertical layer (llm) : integer (default=19)
@@ -44,4 +44,8 @@
 write_period=86400
 
+# pression value whera output is interpolated : real (default=0, no output)
+out_pression_level=85000
+
+
 # etat0 : initial state : string (default=jablonowsky06) : 
 # jablonowsky06, academic, ncar
@@ -74,5 +78,5 @@
 
 # dissipation time graddiv : real (default=5000)
-tau_graddiv = 1800
+tau_graddiv = 350
 
 # number of iteration for graddiv : integer (default=1)
@@ -81,5 +85,5 @@
 
 # dissipation time nxgradrot (default=5000)
-tau_gradrot = 1800
+tau_gradrot = 350
 
 # number of iteration for nxgradrot : integer (default=1)
@@ -88,5 +92,5 @@
 
 # dissipation time divgrad (theta) (default=5000)
-tau_divgrad=1800
+tau_divgrad=350
 
 # number of iteration for divgrad : integer (default=1)
Index: codes/icosagcm/trunk/param_sets/dcmip2012/test4/test4.1/test4.1-2/run.def
===================================================================
--- codes/icosagcm/trunk/param_sets/dcmip2012/test4/test4.1/test4.1-2/run.def	(revision 92)
+++ codes/icosagcm/trunk/param_sets/dcmip2012/test4/test4.1/test4.1-2/run.def	(revision 101)
@@ -7,6 +7,6 @@
 
 # sub splitting of main rhombus : integer (default=1)
-nsplit_i=2
-nsplit_j=3
+nsplit_i=4
+nsplit_j=4
 
 # Number of vertical layer (llm) : integer (default=19)
@@ -44,4 +44,8 @@
 write_period=86400
 
+# pression value whera output is interpolated : real (default=0, no output)
+out_pression_level=85000
+
+
 # etat0 : initial state : string (default=jablonowsky06) : 
 # jablonowsky06, academic, ncar
@@ -74,5 +78,5 @@
 
 # dissipation time graddiv : real (default=5000)
-tau_graddiv = 1800
+tau_graddiv = 350
 
 # number of iteration for graddiv : integer (default=1)
@@ -81,5 +85,5 @@
 
 # dissipation time nxgradrot (default=5000)
-tau_gradrot = 1800
+tau_gradrot = 350
 
 # number of iteration for nxgradrot : integer (default=1)
@@ -88,5 +92,5 @@
 
 # dissipation time divgrad (theta) (default=5000)
-tau_divgrad=1800
+tau_divgrad=350
 
 # number of iteration for divgrad : integer (default=1)
Index: codes/icosagcm/trunk/param_sets/dcmip2012/test4/test4.1/test4.1-3/run.def
===================================================================
--- codes/icosagcm/trunk/param_sets/dcmip2012/test4/test4.1/test4.1-3/run.def	(revision 92)
+++ codes/icosagcm/trunk/param_sets/dcmip2012/test4/test4.1/test4.1-3/run.def	(revision 101)
@@ -7,6 +7,6 @@
 
 # sub splitting of main rhombus : integer (default=1)
-nsplit_i=2
-nsplit_j=3
+nsplit_i=4
+nsplit_j=4
 
 # Number of vertical layer (llm) : integer (default=19)
@@ -44,4 +44,8 @@
 write_period=86400
 
+# pression value whera output is interpolated : real (default=0, no output)
+out_pression_level=85000
+
+
 # etat0 : initial state : string (default=jablonowsky06) : 
 # jablonowsky06, academic, ncar
@@ -74,5 +78,5 @@
 
 # dissipation time graddiv : real (default=5000)
-tau_graddiv = 1800
+tau_graddiv = 350
 
 # number of iteration for graddiv : integer (default=1)
@@ -81,5 +85,5 @@
 
 # dissipation time nxgradrot (default=5000)
-tau_gradrot = 1800
+tau_gradrot = 350
 
 # number of iteration for nxgradrot : integer (default=1)
@@ -88,5 +92,5 @@
 
 # dissipation time divgrad (theta) (default=5000)
-tau_divgrad=1800
+tau_divgrad=350
 
 # number of iteration for divgrad : integer (default=1)