Index: codes/icosagcm/trunk/param_sets/dcmip2012/test1/run11.def
===================================================================
--- codes/icosagcm/trunk/param_sets/dcmip2012/test1/run11.def	(revision 130)
+++ codes/icosagcm/trunk/param_sets/dcmip2012/test1/run11.def	(revision 142)
@@ -6,15 +6,16 @@
 # ------------------------------- Mesh ---------------------------------
 
+# nbp                 20  40  80 160
+# T-edge length (km) 500 250 120  60
+
 # Number of subdivision on a main triangle (nbp) : integer (default=40)
-#nbp=80
-nbp=20
+nbp=80
 
 # sub splitting of main rhombus : integer (default=1)
-nsplit_i=1
-nsplit_j=1
+nsplit_i=2
+nsplit_j=2
 
 # Number of vertical layer (llm) : integer (default=19)
-#llm=60
-llm=20
+llm=60
 
 # disvert : vertical discretisation : string (default='std') : std, ncar, ncar30l
@@ -23,22 +24,24 @@
 # ncar_dz : model layer thickness in meters: real (default=400) 
 # used if disvert=ncar
-#ncar_dz=200.
-ncar_dz=600
+ncar_dz=200.
 
 # optim_it : mesh optimisation : number of iteration : integer (default=0)
-optim_it=0
+optim_it=100
 
-# ------------------------------------------------------------------------
+# ---------------------------------- Time --------------------------------
 
+# scheme type : string ( default='runge_kutta') euler, leapfrog_matsuno, runge_kutta )
+scheme = runge_kutta
 
+# matsuno period : integer ( default=5)
+matsuno_period = 5
 
-# ---------------------------------- Misc --------------------------------
+# timestep : real (default=480s)
+dt = 180.
 
-# number of tracer (nqtot) : integer (default 1)
-nqtot=5
-
-# timestep : real (default=90s)
-#dt = 45.
-dt=180
+# advection called every itau_adv time steps : integer (default 2)
+# standard : umax=100m/s vs c=340m/s (ratio 1:3)
+# in JW06 umax=35m/s vs c=340m/s (ratio 1:10)
+itau_adv=1
 
 # number of timestep (default 100)
@@ -46,37 +49,26 @@
 
 # run length : real (default=dt*itaumax)
-run_length=86400
-# run_length=1036800
+run_length=1036800
 
 # output field period : integer (default none)
-write_period=3600
-#write_period=86400
+write_period=86400
+
+# ---------------------------------- Misc --------------------------------
+
+
+# number of tracer (nqtot) : integer (default 1)
+nqtot=5
 
 # etat0 : initial state : string (default=jablonowsky06) : 
-# jablonowsky06, academic, ncar
+# jablonowsky06, academic, dcmip[1-4]
 etat0=dcmip1
+
+# ------------------------------ Dynamics --------------------------------
 
 # caldyn : computation type for gcm equation : string (default=gcm) : gcm, adv
 caldyn=adv
 
-# ----------------------------------------------------------------------
-
-
-
-
-# ------------------------------ Dynamics --------------------------------
-
-# scheme type : string ( default='adam_bashforth') euler, leapfrog, leapfrog_matsuno, adam_bashforth)
-scheme = adam_bashforth
-
-# matsuno period : integer ( default=5)
-matsuno_period = 5
-
 # guided_type : string (default=none) : none, ncar
 guided_type=dcmip1
-
-# ----------------------------------------------------------------------
-
-
 
 # ------------------------------ Dissipation ---------------------------
@@ -88,5 +80,4 @@
 nitergdiv = 1
 
-
 # dissipation time nxgradrot (default=5000)
 tau_gradrot = 1800
@@ -94,5 +85,4 @@
 # number of iteration for nxgradrot : integer (default=1)
 nitergrot=2
-
 
 # dissipation time divgrad (theta) (default=5000)
@@ -102,14 +92,8 @@
 niterdivgrad=2
 
+# Rayleigh friction : string (default=none) : none, dcmip2_schaer_noshear, dcmip2_schaer_shear
 rayleigh_friction_type=none
-#rayleigh_friction_type=dcmip2_schaer_noshear
-#rayleigh_friction_tau=360.
 
-# -----------------------------------------------------------------------
-
-
-
-
-# -------------------- parameters for NCAR test cases ------------------------
+# -------------------- Parameters for NCAR test cases ------------------------
 
 # NCAR advection test, initial tracer : string ( default='cos_bell')
Index: codes/icosagcm/trunk/param_sets/dcmip2012/test4/test4.1/test4.1-0/earth_const.def
===================================================================
--- codes/icosagcm/trunk/param_sets/dcmip2012/test4/test4.1/test4.1-0/earth_const.def	(revision 130)
+++ codes/icosagcm/trunk/param_sets/dcmip2012/test4/test4.1/test4.1-0/earth_const.def	(revision 142)
@@ -19,2 +19,5 @@
 # Scale factor for small planet experiment : real (default=1.)
 scale_factor=1.
+
+# Precision of NetCDF output
+netcdf_prec = float
Index: codes/icosagcm/trunk/param_sets/dcmip2012/test4/test4.1/test4.1-0/run.def
===================================================================
--- codes/icosagcm/trunk/param_sets/dcmip2012/test4/test4.1/test4.1-0/run.def	(revision 130)
+++ codes/icosagcm/trunk/param_sets/dcmip2012/test4/test4.1/test4.1-0/run.def	(revision 142)
@@ -6,7 +6,10 @@
 nbp=80
 
+# nbp                 20  40  80 160
+# T-edge length (km) 500 250 120  60
+
 # sub splitting of main rhombus : integer (default=1)
-nsplit_i=4
-nsplit_j=4
+nsplit_i=2
+nsplit_j=2
 
 # Number of vertical layer (llm) : integer (default=19)
@@ -21,44 +24,8 @@
 
 # optim_it : mesh optimisation : number of iteration : integer (default=0)
-optim_it=0
+#optim_it=1000
+optim_it=100
 
-# ------------------------------------------------------------------------
-
-
-
-# ---------------------------------- Misc --------------------------------
-
-# number of tracer (nqtot) : integer (default 1)
-nqtot=2
-
-# timestep : real (default=240s)
-dt = 240.
-
-# number of timestep (default 100)
-# itaumax = 10000
-
-# run length : real (default=dt*itaumax)
-run_length=2592000
-
-# output field period : integer (default none)
-write_period=86400
-
-# pression value whera output is interpolated : real (default=0, no output)
-out_pression_level=85000
-
-
-# etat0 : initial state : string (default=jablonowsky06) : 
-# jablonowsky06, academic, ncar
-etat0=dcmip4
-
-# caldyn : computation type for gcm equation : string (default=gcm) : gcm, adv
-caldyn=gcm
-
-# ----------------------------------------------------------------------
-
-
-
-
-# ------------------------------ Dynamics --------------------------------
+# ---------------------------------- Time---------------------------------
 
 # scheme type : string ( default='runge_kutta') euler, leapfrog_matsuno, runge_kutta )
@@ -68,39 +35,77 @@
 matsuno_period = 5
 
+# timestep : real (default=480s)
+dt = 240.
+
+# advection called every itau_adv time steps : integer (default 2)
+# standard : umax=100m/s vs c=340m/s (ratio 1:3)
+# in JW06 umax=35m/s vs c=340m/s (ratio 1:10)
+itau_adv=3
+
+# number of timestep (default 100)
+# itaumax = 10000
+
+# run length : real (default=dt*itaumax)
+run_length=2592000
+#run_length=432000
+#run_length=86400
+
+# output field period : integer (default none)
+write_period=86400
+# write_period=14400
+
+# ---------------------------------- Misc --------------------------------
+
+# number of tracer (nqtot) : integer (default 1)
+nqtot=2
+
+# pression value where output is interpolated : real (default=0, no output)
+out_pression_level=85000
+
+# etat0 : initial state : string (default=jablonowsky06) : 
+# jablonowsky06, academic, ncar
+etat0=dcmip4
+
+# ------------------------------ Dynamics --------------------------------
+
+# caldyn : computation type for gcm equation : string (default=gcm) : gcm, adv
+caldyn=gcm
+
+# caldyn_conserv : string (default=energy) : energy,enstrophy
+caldyn_conserv=energy
+
+# caldyn_exner : scheme for computing Exner function : string (default=direct) : direct,lmdz
+caldyn_exner=direct
+
+# caldyn_hydrostat : scheme for computing geopotential : string (default=direct) : direct,lmdz
+caldyn_hydrostat=direct
+
 # guided_type : string (default=none) : none, ncar
 guided_type=none
 
-caldyn_conserv=energy
-
-# ----------------------------------------------------------------------
-
-
-
-# ------------------------------ Dissipation ---------------------------
+# ---------------------------------- Dissipation ---------------------------------
 
 # dissipation time graddiv : real (default=5000)
-tau_graddiv = 350
+tau_graddiv = 2500
 
 # number of iteration for graddiv : integer (default=1)
- nitergdiv = 1
-
+nitergdiv = 2
 
 # dissipation time nxgradrot (default=5000)
-tau_gradrot = 350
+tau_gradrot = 2500
 
 # number of iteration for nxgradrot : integer (default=1)
 nitergrot=2
 
-
 # dissipation time divgrad (theta) (default=5000)
-tau_divgrad=350
+tau_divgrad=2500
 
 # number of iteration for divgrad : integer (default=1)
 niterdivgrad=2
 
-# -----------------------------------------------------------------------
+# Rayleigh friction : string (default=none) : none, dcmip2_schaer_noshear, dcmip2_schaer_shear
+rayleigh_friction_type=none
 
-
-# -------------------- physics ------------------------------------------
+# -------------------------------- Physics -------------------------------------
 
 # kind of physics : string : none, dcmip (default=none)
@@ -109,8 +114,4 @@
 # testcase physics for dcmip : INTEGER : 1, 2 (default=1)
 dcmip_physics=1
-
-# -----------------------------------------------------------------------
-
-
 
 # -------------------- parameters for NCAR test cases ------------------------