Index: /codes/icosagcm/trunk/arch/arch-x86_skd.fcm
===================================================================
--- /codes/icosagcm/trunk/arch/arch-x86_skd.fcm	(revision 150)
+++ /codes/icosagcm/trunk/arch/arch-x86_skd.fcm	(revision 150)
@@ -0,0 +1,15 @@
+%COMPILER            gfortran 
+%LINK                gfortran
+%AR                  ar
+%MAKE                make
+%FPP_FLAGS           -P -traditional
+%FPP_DEF             KEY_NONE
+%BASE_FFLAGS         -I/home/sarvesh/LMDZS/netcdf-4.0.1/include -fdefault-real-8
+%PROD_FFLAGS         -O3 
+%DEV_FFLAGS          -p -g -O 
+%DEBUG_FFLAGS        -p -g  -fbacktrace -fbounds-check
+%MPI_FFLAGS
+%OMP_FFLAGS          -openmp
+%BASE_LD             -p  -L/home/sarvesh/LMDZS/netcdf-4.0.1/lib  -lnetcdf  -lblas -llapack
+%MPI_LD             
+%OMP_LD              -openmp
Index: /codes/icosagcm/trunk/arch/arch-x86_skd.path
===================================================================
--- /codes/icosagcm/trunk/arch/arch-x86_skd.path	(revision 150)
+++ /codes/icosagcm/trunk/arch/arch-x86_skd.path	(revision 150)
@@ -0,0 +1,9 @@
+#NETCDF_LIBDIR='/usr/lib -lnetcdf'
+#NETCDF_INCDIR='/usr/include'
+NETCDF_LIBDIR="-L /home/sarvesh/LMDZS/netcdf-4.0.1/lib"
+NETCDF_INCDIR="-I /home/sarvesh/LMDZS/netcdf-4.0.1/include"
+NETCDF_LIB="-lnetcdf"
+
+MPI_INCDIR=""
+MPI_LIBDIR=""
+MPI_LIB=""
Index: /codes/icosagcm/trunk/arch/arch-x86_skdmpi.fcm
===================================================================
--- /codes/icosagcm/trunk/arch/arch-x86_skdmpi.fcm	(revision 150)
+++ /codes/icosagcm/trunk/arch/arch-x86_skdmpi.fcm	(revision 150)
@@ -0,0 +1,15 @@
+%COMPILER            mpif90 
+%LINK                mpif90
+%AR                  ar
+%MAKE                make
+%FPP_FLAGS           -P -traditional
+%FPP_DEF             KEY_NONE
+%BASE_FFLAGS         -I/home/sarvesh/LMDZS/netcdf-4.0.1/include -fdefault-real-8
+%PROD_FFLAGS         -O3 
+%DEV_FFLAGS          -p -g -O 
+%DEBUG_FFLAGS        -p -g  -fbacktrace -fbounds-check
+%MPI_FFLAGS
+%OMP_FFLAGS          -fopenmp
+%BASE_LD             -p  -L/home/sarvesh/LMDZS/netcdf-4.0.1/lib  -lnetcdf  -lblas -llapack
+%MPI_LD             
+%OMP_LD              -fopenmp
Index: /codes/icosagcm/trunk/arch/arch-x86_skdmpi.path
===================================================================
--- /codes/icosagcm/trunk/arch/arch-x86_skdmpi.path	(revision 150)
+++ /codes/icosagcm/trunk/arch/arch-x86_skdmpi.path	(revision 150)
@@ -0,0 +1,9 @@
+#NETCDF_LIBDIR='/usr/lib -lnetcdf'
+#NETCDF_INCDIR='/usr/include'
+NETCDF_LIBDIR="-L /home/sarvesh/LMDZS/netcdf-4.0.1/lib"
+NETCDF_INCDIR="-I /home/sarvesh/LMDZS/netcdf-4.0.1/include"
+NETCDF_LIB="-lnetcdf"
+
+MPI_INCDIR=""
+MPI_LIBDIR=""
+MPI_LIB=""
Index: /codes/icosagcm/trunk/bld.cfg
===================================================================
--- /codes/icosagcm/trunk/bld.cfg	(revision 149)
+++ /codes/icosagcm/trunk/bld.cfg	(revision 150)
@@ -29,5 +29,5 @@
 bld::tool::fflags    %FFLAGS 
 bld::tool::fppkeys   %CPP_KEY %FPP_DEF
-bld::tool::fpp       %FPP
+#bld::tool::fpp       %FPP
 
 # Pre-process code before analysing dependencies
Index: /codes/icosagcm/trunk/clean
===================================================================
--- /codes/icosagcm/trunk/clean	(revision 150)
+++ /codes/icosagcm/trunk/clean	(revision 150)
@@ -0,0 +1,6 @@
+rm -rf ./obj/*
+rm -rf ./done/*
+rm -rf ./inc/*
+rm -rf ./flags/*
+rm -rf ./ppsrc/*
+
Index: /codes/icosagcm/trunk/compile
===================================================================
--- /codes/icosagcm/trunk/compile	(revision 150)
+++ /codes/icosagcm/trunk/compile	(revision 150)
@@ -0,0 +1,2 @@
+./make_icosa -prod -arch x86_skd 
+#./make_icosa -prod -arch x86_skdmpi -parallel mpi
Index: /codes/icosagcm/trunk/param_sets/dcmip2012/test4/test4.1/test4.1-0/run.def
===================================================================
--- /codes/icosagcm/trunk/param_sets/dcmip2012/test4/test4.1/test4.1-0/run.def	(revision 149)
+++ /codes/icosagcm/trunk/param_sets/dcmip2012/test4/test4.1/test4.1-0/run.def	(revision 150)
@@ -4,5 +4,5 @@
 
 # Number of subdivision on a main triangle (nbp) : integer (default=40)
-nbp=80
+nbp=40
 
 # nbp                 20  40  80 160
@@ -10,6 +10,6 @@
 
 # sub splitting of main rhombus : integer (default=1)
-nsplit_i=2
-nsplit_j=2
+nsplit_i=1
+nsplit_j=1
 
 # Number of vertical layer (llm) : integer (default=19)
@@ -25,10 +25,10 @@
 # optim_it : mesh optimisation : number of iteration : integer (default=0)
 #optim_it=1000
-optim_it=100
+optim_it=0
 
 # ---------------------------------- Time---------------------------------
 
 # scheme type : string ( default='runge_kutta') euler, leapfrog_matsuno, runge_kutta )
-scheme = runge_kutta
+scheme = runge_kutta   leapfrog_matsuno 
 
 # matsuno period : integer ( default=5)
@@ -36,5 +36,5 @@
 
 # timestep : real (default=480s)
-dt = 240.
+dt = 480.
 
 # advection called every itau_adv time steps : integer (default 2)
@@ -87,5 +87,5 @@
 
 # dissipation time graddiv : real (default=5000)
-tau_graddiv = 2500
+tau_graddiv = 5000
 
 # number of iteration for graddiv : integer (default=1)
@@ -93,5 +93,5 @@
 
 # dissipation time nxgradrot (default=5000)
-tau_gradrot = 2500
+tau_gradrot = 5000
 
 # number of iteration for nxgradrot : integer (default=1)
@@ -99,5 +99,5 @@
 
 # dissipation time divgrad (theta) (default=5000)
-tau_divgrad=2500
+tau_divgrad= 5000
 
 # number of iteration for divgrad : integer (default=1)